<div class="simplecheckout-block" id="simplecheckout_cart" <?php echo $hide ? 'data-hide="true"' : '' ?> <?php echo $has_error ? 'data-error="true"' : '' ?>>
<?php if ($display_header) { ?>
    <div class="checkout-heading panel-heading"><?php echo $text_cart ?></div>
<?php } ?>
<?php if ($attention) { ?>
    <div class="simplecheckout-warning-block"><?php echo $attention; ?></div>
<?php } ?>
<?php if ($error_warning) { ?>
    <div class="simplecheckout-warning-block"><?php echo $error_warning; ?></div>
<?php } ?>





			<div class="cart-sidebar">
					<div class="cart-sidebar__title"><h3><?php echo $text_cart; ?></h3></div>
					<?php if ($products || $vouchers) { ?>
						<ul class="cart__list">
						   <?php foreach ($products as $product) { ?>
							<li class="cart__list-item">
								<div class="cart__img">
									<a href="<?php echo $product['href']; ?>"><img src="<?php echo $product['thumb']; ?>" alt="<?php echo $product['name']; ?>"></a>
								</div>
								<div class="cart__descr">
									<span class="cart__article"><?php echo $product['model']; ?></span>
									<a href="<?php echo $product['href']; ?>" class="cart__model"><?php echo $product['name']; ?></a>
									<?php if (!$product['stock'] && ($config_stock_warning || !$config_stock_checkout)) { ?>
										<span class="product-warning">***</span>
									<?php } ?>
									<span class="cart__price"><?php echo $product['total']; ?></span>
									<span class="cart__count">
										<div class="quantity">
											<div class="spinner-wrap">
												<span class="ui-spinner ui-corner-all ui-widget ui-widget-content">
													<input class="spinner ui-spinner-input" data-onchange="changeProductQuantity" <?php echo $quantity_step_as_minimum ? 'data-minimum="' . $product['minimum'] . '"' : '' ?> name="quantity[<?php echo !empty($product['cart_id']) ? $product['cart_id'] : $product['key']; ?>]" value="<?php echo $product['quantity']; ?>" type="text">
													<a data-onclick="increaseProductQuantity" tabindex="-1" aria-hidden="true" class="ui-button ui-widget ui-spinner-button ui-spinner-up ui-corner-tr ui-button-icon-only" role="button">
														<span class="ui-button-icon ui-icon ui-icon-triangle-1-n"></span>
														<span class="ui-button-icon-space"> </span>
													</a>
													<a data-onclick="decreaseProductQuantity" tabindex="-1" aria-hidden="true" class="ui-button ui-widget ui-spinner-button ui-spinner-down ui-corner-br ui-button-icon-only" role="button">
														<span class="ui-button-icon ui-icon ui-icon-triangle-1-s"></span>
														<span class="ui-button-icon-space"> </span>
													</a>
												</span>
											</div>
										</div>
									</span>
									<?php if ($product['option']) { ?>
									<?php foreach ($product['option'] as $option) { ?>
									<span class="cart__count"><?php echo $option['name']; ?> <?php echo $option['value']; ?></span>
									<?php } ?>
									<?php } ?>
									<?php if (!empty($product['recurring'])) { ?>
									<span class="cart__count"><?php echo $text_recurring_item; ?> <?php echo $product['recurring']; ?></span>
									<?php } ?>
									<?php if ($product['reward']) { ?>
									<span class="cart__count"><?php echo $product['reward']; ?></span>
									<?php } ?>
								</div>
								<a data-onclick="removeProduct" data-product-key="<?php echo !empty($product['cart_id']) ? $product['cart_id'] : $product['key'] ?>" class="cart__delete" title="<?php echo $button_remove; ?>">
								<svg class="icon-cross">
									<use xlink:href="#cross"></use>
								</svg>
								</a>
							</li>
       						   <?php } ?>
							    <?php foreach ($vouchers as $voucher_info) { ?>
							<li class="cart__list-item">
								<div class="cart__descr">
									<span class="cart__model"><?php echo $voucher_info['description']; ?></span>
									<span class="cart__price"><?php echo $voucher_info['amount']; ?></span>
									<span class="cart__count">1</span>
								</div>
								<a data-onclick="removeGift"  data-gift-key="<?php echo $voucher_info['key']; ?>" class="cart__delete" title="<?php echo $button_remove; ?>">
								<svg class="icon-cross">
									<use xlink:href="#cross"></use>
								</svg>
								</a>
							</li>
							   <?php } ?>
						</ul>
					<div class="cart-sidebar__bottom">
						<?php foreach ($totals as $total) { ?>
							<?php if ($total['code'] == 'total') { ?>
								<span class="cart-sidebar__total"><?php echo $total['title']; ?> <span><?php echo $total['text']; ?></span></span>
							<?php }else{ ?>						
								<span class="cart-sidebar__info"><?php echo $total['title']; ?> <span><?php echo $total['text']; ?></span>&nbsp;&nbsp;&nbsp;
								<?php if ($total['code'] == 'coupon') { ?>
									<a data-onclick="removeCoupon" title="<?php echo $button_remove; ?>" class="cart__delete">
									<svg class="icon-cross">
										<use xlink:href="#cross"></use>
									</svg>
									</a>
								<?php } ?>
								<?php if ($total['code'] == 'voucher') { ?>
									<a data-onclick="removeVoucher" title="<?php echo $button_remove; ?>"  class="cart__delete">
									<svg class="icon-cross">
										<use xlink:href="#cross"></use>
									</svg>
									</a>
								<?php } ?>
								<?php if ($total['code'] == 'reward') { ?>
									<a data-onclick="removeReward" title="<?php echo $button_remove; ?>" class="cart__delete">
									<svg class="icon-cross">
										<use xlink:href="#cross"></use>
									</svg>
									</a>
								<?php } ?>
								</span>
							<?php } ?>
						<?php } ?>

						<?php } else { ?>
						<span class="cart-sidebar__info"><?php echo $text_empty; ?></span>
						<?php } ?>
					</div>
			</div>
			<?php if (isset($modules['coupon']) || (isset($modules['reward']) && $points > 0) || isset($modules['voucher'])) { ?>
					<div class="cart-sidebar-simple">
						<?php if (isset($modules['coupon'])) { ?>
							<div class="cart__coupon">
								<span class="fake-input fake-input--coupon">
									<input type="text" name="coupon" value="<?php echo $coupon; ?>" data-onchange="reloadAll" placeholder="<?php echo $entry_coupon; ?>" class="cart__coupon-input">
									<button type="button" value="<?php echo $button_update; ?>" data-onclick="reloadAll" class="coupon-btn">
									<svg class="icon-arrow-long">
										<use xlink:href="#arrow-long-right"></use>
									</svg>
									</button>
								</span>
							</div>
						<?php } ?>
						<?php if (isset($modules['reward']) && $points > 0) { ?>
							<div class="cart__coupon">
								<span class="fake-input fake-input--coupon">
									<input type="text" name="reward" value="<?php echo $reward; ?>" data-onchange="reloadAll" placeholder="<?php echo $entry_reward; ?>" class="cart__coupon-input">
									<button type="button" value="<?php echo $button_update; ?>" data-onclick="reloadAll" class="coupon-btn">
									<svg class="icon-arrow-long">
										<use xlink:href="#arrow-long-right"></use>
									</svg>
									</button>
								</span>
							</div>
						<?php } ?>
						<?php if (isset($modules['voucher'])) { ?>
							<div class="cart__coupon">
								<span class="fake-input fake-input--coupon">
									<input type="text" name="voucher" value="<?php echo $voucher; ?>" data-onchange="reloadAll" placeholder="<?php echo $entry_voucher; ?>" class="cart__coupon-input">
									<button type="button" value="<?php echo $button_update; ?>" data-onclick="reloadAll" class="coupon-btn">
									<svg class="icon-arrow-long">
										<use xlink:href="#arrow-long-right"></use>
									</svg>
									</button>
								</span>
							</div>
						<?php } ?>
					</div>
			<?php } ?>

						<input type="hidden" name="remove" value="" id="simplecheckout_remove">
						<div style="display:none;" id="simplecheckout_cart_total"><?php echo $cart_total ?></div>
<?php if ($display_weight) { ?>
    <div style="display:none;" id="simplecheckout_cart_weight"><?php echo $weight ?></div>
<?php } ?>
<?php if (!$display_model) { ?>
    <style>
    .simplecheckout-cart .cart__article {
        display: none;
    }
    </style>
<?php } ?>

</div>